build.sh 7.5 KB

123456789101112131415161718192021222324252627282930313233343536373839404142434445464748495051525354555657585960616263646566676869707172737475767778798081828384858687888990919293949596979899100101102103104105106107108109110111112113114115116117118119120121122123124125126127128129130131132133134135136137138139140141142143144145146147148149150151152153154155156157158159160161162163164165166167168169170171172173174175176177178179180181182183184185186187188189190191192
  1. #!/bin/bash
  2. # (c) 2014-2015 Helge Jung <hej@c3pb.de>
  3. #
  4. # This script is controlled by environment variables, the
  5. # first two being mandatory:
  6. #
  7. # BASE = Gluon Version (tag or commit, i.e. v2014.4)
  8. # BRANCH = Firmware Branch (stable/testing/experimental)
  9. # SITE = specific site repository commit-id (leave blank to use HEAD)
  10. # VERSION = the version tag (can only be empty if BRANCH=experimental)
  11. # BUILD_TS = build timestamp (format: %Y-%m-%d %H:%M:%S)
  12. # BROKEN = 0 (default) or 1, build the untested hardware model firmwares, too
  13. # MAKEJOBS = number of compiler processes running in parallel (default: number of CPUs/Cores)
  14. # TARGETS = a space separated list of target platforms (if unset, all platforms will be build)
  15. #
  16. function get_all_supported_platforms()
  17. {
  18. local buffer;
  19. for val in $(ls ${1}) ; do
  20. [ -d "./${1}/${val}" ] || continue
  21. buffer="${buffer} ${val}"
  22. done
  23. echo ${buffer}
  24. }
  25. if [ "_$BRANCH" == "_" ]; then
  26. echo "Please specify BRANCH environment variable." >&2
  27. exit 1
  28. fi
  29. if [ "_$BASE" == "_" ]; then
  30. echo "Please specify BASE environment variable (Gluon, i.e. 'v2014.3' or commit-id)." >&2
  31. exit 1
  32. fi
  33. if [ "${BRANCH}" != "experimental" -a "${BASE}" == "HEAD" ] ; then
  34. echo "HEAD is not an allowed BASE-identifier for non-experimental builds." >&2
  35. echo "Either use a tagged commit or the commit-SHA itself." >&2
  36. exit 1
  37. fi
  38. if [ "_$VERSION" == "_" -a "$BRANCH" != "experimental" ]; then
  39. echo "Please specify VERSION environment variable (not necessary for experimental branch)." >&2
  40. exit 1
  41. fi
  42. MY_DIR=$(dirname $0)
  43. MY_DIR=$(readlink -f "$MY_DIR")
  44. CODE_DIR="src"
  45. OUTPUT_DIR="${MY_DIR}/output"
  46. BUILD_INFO_FILENAME="build-info.txt"
  47. VERSIONS_INFO_DIR="versions"
  48. pushd $MY_DIR > /dev/null
  49. [ "_$BUILD_TS" == "_" ] && export BUILD_TS=$(date +"%Y-%m-%d %H:%M:%S")
  50. . functions.sh
  51. ### CHECK THAT VERSION DOES NOT YET EXISTS
  52. [ -n "$VERSION" -a -x "${VERSIONS_INFO_DIR}/${VERSION}" ] && abort "There exists a version file for '$VERSION' ... you are trying to do something really stupid, aren't you?"
  53. ### INIT /src IF NECESSARY
  54. if [ ! -d "$CODE_DIR" ]; then
  55. info "Code directory does not exist yet - fetching Gluon ..."
  56. git clone https://github.com/freifunk-gluon/gluon.git "$CODE_DIR"
  57. fi
  58. ### INIT /src/site IF NECESSARY
  59. if [ ! -d "$CODE_DIR/site" ]; then
  60. info "Site repository does not exist, fetching it ..."
  61. git clone https://git.c3pb.de/freifunk-pb/site-ffpb.git "$CODE_DIR/site"
  62. fi
  63. ### CHECKOUT GLUON
  64. progress "Checking out GLUON '$BASE' ..."
  65. cd $CODE_DIR
  66. # TODO: check if gluon got modified and bail out if necessary
  67. git fetch ; git checkout -q $BASE
  68. [ "$?" -eq "0" ] || abort "Failed to checkout '$BASE' gluon base version, mimimi." >&2
  69. GLUON_COMMIT=$(git rev-list --max-count=1 HEAD)
  70. ### CHECKOUT SITE REPO
  71. progress "Checking out SITE REPO ..."
  72. cd site
  73. # TODO: check if site got modified locally and bail out if necessary
  74. if [ "_$SITE" == "_" ]; then
  75. # no specific site given - get the most current one
  76. git checkout -q $BRANCH ; git pull
  77. [ "$?" -eq "0" ] || abort "Failed to get newest '$BRANCH' in site repository, mimimi."
  78. else
  79. # commit given - use this one
  80. git checkout -q $SITE || abort "Failed to checkout requested site commit, mimimi."
  81. fi
  82. SITE_COMMIT=$(git rev-list --max-count=1 HEAD)
  83. cd ..
  84. ### CLEAN
  85. if [ -d "./build/" -a "$BRANCH" != "experimental" ]; then
  86. progress "Cleaning your build environment ..."
  87. make dirclean
  88. fi
  89. ### PREPARE
  90. progress "Preparing the build environment (make update) ..."
  91. make update
  92. [ "$?" -eq "0" ] || abort "Failed to update the build environment, mimimi."
  93. # we are now ready to produke the firmware images, so let's "save" our state
  94. build_info_path="${OUTPUT_DIR}/${BRANCH}/${BUILD_INFO_FILENAME}"
  95. progress "Saving build information to: ${build_info_path}"
  96. mkdir -p $(dirname ${build_info_path})
  97. [ "$?" -eq "0" ] || abort "Unable to create output directory: $(dirname ${build_info_path})"
  98. touch $(dirname ${build_info_path})
  99. [ "$?" -eq "0" ] || abort "Cannot create build information file: ${build_info_path}"
  100. echo "VERSION=${VERSION}" >> ${build_info_path}
  101. echo "GLUON=${GLUON_COMMIT} # ${BASE}" >> ${build_info_path}
  102. echo "BRANCH=${BRANCH}" >> ${build_info_path}
  103. echo "SITE=${SITE_COMMIT} # ${VERSION}" >> ${build_info_path}
  104. echo "TS=${BUILD_TS}" >> ${build_info_path}
  105. ### BUILD FIRMWARE
  106. progress "Building the firmware - please stand by!"
  107. [ -n "${BROKEN}" ] || BROKEN=0
  108. [ -n "${MAKEJOBS}" ] || MAKEJOBS=$(grep -c "^processor" /proc/cpuinfo)
  109. [ -n "${TARGETS}" ] || TARGETS=$(get_all_supported_platforms "./targets")
  110. if [ "${BRANCH}" == "experimental" -a -z "${VERSION}" ] ; then
  111. default_release_pattern=$( awk -F" := " '/^DEFAULT_GLUON_RELEASE/ { gsub("shell ", "", $2); print $2; }' ./site/site.mk )
  112. VERSION=$(eval echo ${default_release_pattern})
  113. fi
  114. for target in ${TARGETS} ; do
  115. # configure build environment for our current target
  116. export GLUON_TARGET="${target}"
  117. gluon_build_env_vars="GLUON_TARGET=\"${target}\" GLUON_BRANCH=\"${BRANCH}\" GLUON_RELEASE=\"${VERSION}\" BROKEN=\"${BROKEN}\""
  118. # prepare build environment for our current target
  119. progress "Preparing build environment for target ${target}."
  120. [ "${BRANCH}" == "experimental" ] || make clean
  121. make -j ${MAKEJOBS} prepare-target
  122. # need to have a toolchain for the particular target
  123. progress "Building toolchain for target ${target}."
  124. make -j ${MAKEJOBS} toolchain/install
  125. [ "$?" -eq "0" ] || abort "Unable to build toolchain for target. Aborting."
  126. # now we can start building the images for the target platform
  127. progress "Building FFPB-flavoured Gluon firmware for target ${target}. You'd better go and fetch some c0ffee!"
  128. make_targets="prepare"
  129. eval "${gluon_build_env_vars} faketime \"$BUILD_TS\" make -j ${MAKEJOBS} ${make_targets}"
  130. [ "$?" -eq "0" ] || abort "Failed to build firmware for target-platform ${target}."
  131. # finally compile the firmware binaries
  132. progress "Compiling binary firmware images."
  133. faketime "$BUILD_TS" make images
  134. [ "$?" -eq "0" ] || abort "Failed to assemble images for target-platform ${target}."
  135. done
  136. cd ..
  137. # compress all binaries into 7z archive
  138. progress "Assembling images.7z ..."
  139. [ -e "${OUTPUT_DIR}/${BRANCH}/images.7z" ] && rm "${OUTPUT_DIR}/${BRANCH}/images.7z"
  140. 7z a "${OUTPUT_DIR}/${BRANCH}/images.7z" ${CODE_DIR}/images/sysupgrade/*.bin ${CODE_DIR}/images/factory/*.bin || abort "Failed to assemble images (did you install p7zip-full?)."
  141. # generate, franken-merge, and copy manifests
  142. progress "Generating and copying manifest ..."
  143. pushd $CODE_DIR
  144. for target in ${TARGETS} ; do
  145. GLUON_TARGET="${target}" GLUON_BRANCH=$BRANCH make manifest || abort "Failed to generate the manifest, try running 'make manifest' in '$CODE_DIR' directory manually."
  146. mv ./images/sysupgrade/${BRANCH}.manifest ./images/sysupgrade/${target}.${BRANCH}.manifest
  147. done
  148. frankenmerge_manifest_file="./images/sysupgrade/${BRANCH}.manifest"
  149. echo "BRANCH=${BRANCH}" > ${frankenmerge_manifest_file}
  150. echo "DATE=${BUILD_TS}$(date +%:z)" >> ${frankenmerge_manifest_file}
  151. echo "PRIORITY=0" >> ${frankenmerge_manifest_file}
  152. echo "" >> ${frankenmerge_manifest_file}
  153. grep -hE "*.bin$" ./images/sysupgrade/*.${BRANCH}.manifest | sort >> ${frankenmerge_manifest_file}
  154. popd
  155. cp "${CODE_DIR}/images/sysupgrade/${BRANCH}.manifest" "${OUTPUT_DIR}/${BRANCH}/"
  156. # Saving a copy of the build info file as reference
  157. progress "Building a greater and brighter firmware finished successfully. Saving build information at: ${VERSIONS_INFO_DIR}/${VERSION}"
  158. cp -p "${build_info_path}" "${VERSIONS_INFO_DIR}/${VERSION}"
  159. # The end. Finally.
  160. success "We're done, go and enjoy your new firmware in ${OUTPUT_DIR}/${BRANCH}!"
  161. popd > /dev/null